﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using Telerik.Windows.Controls.Scheduler;

namespace SchedulerCustomTheme
{
    public class TimeSlotsWorkingHoursConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            TimeSlot slot = value as TimeSlot;
            if (slot != null)
            {
                if (parameter != null && parameter.ToString() == "Month" && IsWorkingDay(slot) )
                {
                    return new SolidColorBrush(Colors.Orange);
                }
                else if (IsWorkingHour(slot))
                {
                    return new SolidColorBrush(Colors.Orange);
                } 
                return new SolidColorBrush(Colors.White);
                
            }
            else
            {
                return new SolidColorBrush(Colors.White);
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        private bool IsWorkingHour(TimeSlot slot)
        {
            return (slot.Start.Hour >= 8 && slot.End.Hour <= 17 && slot.End.Hour > 0 &&  IsWorkingDay(slot));
        }

        public bool IsWorkingDay(TimeSlot slot)
        {
            return slot.Start.DayOfWeek >= DayOfWeek.Monday && slot.End.DayOfWeek <= DayOfWeek.Saturday;
        }
    }
}
